# Frontle BottomSheet

> BottomSheet UI in Frontle
>

![화면-기록-2022-07-12-오후-5.15.45](https://user-images.githubusercontent.com/49587288/197342550-9b052bac-24f0-4e15-ae98-aee8b046e378.gif)

## Usage

```javascript
// at css file
.sheetPosition{
    position: fixed;
}
.contentsFontSize{
    font-size: 16px;
}
.contentsColor{
    color: black;
}

// at js file
import frontle_bottomsheet from "browser_modules/frontle-bottomsheet/module.js";
const {BottomSheet} = frontle_bottomsheet;

let bottomSheet = new BottomSheet(`<button id="closeButton">close</button>`);
bottomSheet.height = 100;
bottomSheet.startY = -50;
bottomSheet.sheetClass = 'sheetPosition';
bottomSheet.sheetContentsClass = 'contentsFontSize contentsColor';
bottomSheet.sheetBackgroundClass = '';
bottomSheet.start = () => {
    console.log('bottom sheet start!');

    document.getElementById('closeButton').onclick = () => {
        bottomSheet.close();
    }
}
bottomSheet.open();
```

## Install

**Frontle**

```shell
frontle install frontle-bottomsheet
```

**Download files**

https://github.com/Artifriends-inc/Frontle-BottomSheet

## API

#### new bottomSheet(html)

Create a bottom sheet object

```javascript
let bottomSheet = new BottomSheet(`<button id="closeButton">close</button>`);
```

#### .sheetClass 

#### .sheetContentsClass 

#### .sheetBackgroundClass

Set the css class of a bottom sheet

```javascript
bottomSheet.sheetClass = 'sheetPosition';
bottomSheet.sheetContentsClass = 'contentsFontSize contentsColor';
bottomSheet.sheetBackgroundClass = '';
```

#### .height

Set bottom sheet height

```javascript
bottomSheet.height = 50;
```

#### .startY

Set bottom sheet start y position

```javascript
bottomSheet.startY = 0;
```

#### .backgroundClickExit

Set whether bottom sheet can be closed by clicking on bottom sheet background

```javascript
bottomSheet.backgroundClickExit = true;
```

#### .awake

This lifecycle runs before bottom sheet rendering

```javascript
bottomSheet.awake = () => { console.log('before rendering') }
```

#### .start

This lifecycle runs after bottom sheet rendered

```javascript
bottomSheet.start = () => { console.log('after rendering') }
```

#### .end

This lifecycle runs before bottom sheet termination

```javascript
bottomSheet.end = () => { console.log('before termination') }
```

#### .sleep

This lifecycle runs after bottom sheet termination

```javascript
bottomSheet.sleep = () => { console.log('after termination') }
```

#### .open()

Open bottom sheet

```javascript
bottomSheet.open();
```

#### .close()

Close bottom sheet

```javascript
bottomSheet.close();
```

## People

The original author of frontle-bottomsheet is [MushStory](https://github.com/MushStory)

## License

 [MIT](LICENSE)
